- NAME
- SYNOPSIS
- DESCRIPTION
- RETURN VALUES
- SEE ALSO
- COPYRIGHT

# NAME

BN_add, BN_sub, BN_mul, BN_sqr, BN_div, BN_mod, BN_nnmod, BN_mod_add, BN_mod_sub, BN_mod_mul, BN_mod_sqr, BN_exp, BN_mod_exp, BN_gcd - arithmetic operations on BIGNUMs

# SYNOPSIS

     #include <openssl/bn.h>

     int BN_add(BIGNUM *r, const BIGNUM *a, const BIGNUM *b);

     int BN_sub(BIGNUM *r, const BIGNUM *a, const BIGNUM *b);

     int BN_mul(BIGNUM *r, BIGNUM *a, BIGNUM *b, BN_CTX *ctx);

     int BN_sqr(BIGNUM *r, BIGNUM *a, BN_CTX *ctx);

     int BN_div(BIGNUM *dv, BIGNUM *rem, const BIGNUM *a, const BIGNUM *d,
             BN_CTX *ctx);

     int BN_mod(BIGNUM *rem, const BIGNUM *a, const BIGNUM *m, BN_CTX *ctx);

     int BN_nnmod(BIGNUM *r, const BIGNUM *a, const BIGNUM *m, BN_CTX *ctx);

     int BN_mod_add(BIGNUM *r, BIGNUM *a, BIGNUM *b, const BIGNUM *m,
             BN_CTX *ctx);

     int BN_mod_sub(BIGNUM *r, BIGNUM *a, BIGNUM *b, const BIGNUM *m,
             BN_CTX *ctx);

     int BN_mod_mul(BIGNUM *r, BIGNUM *a, BIGNUM *b, const BIGNUM *m,
             BN_CTX *ctx);

     int BN_mod_sqr(BIGNUM *r, BIGNUM *a, const BIGNUM *m, BN_CTX *ctx);

     int BN_exp(BIGNUM *r, BIGNUM *a, BIGNUM *p, BN_CTX *ctx);

     int BN_mod_exp(BIGNUM *r, BIGNUM *a, const BIGNUM *p,
             const BIGNUM *m, BN_CTX *ctx);

     int BN_gcd(BIGNUM *r, BIGNUM *a, BIGNUM *b, BN_CTX *ctx);

# DESCRIPTION

BN_add() adds a and b and places the result in r (`r=a+b`). r may be the same BIGNUM as a or b.

BN_sub() subtracts b from a and places the result in r (`r=a-b`). r may be the same BIGNUM as a or b.

BN_mul() multiplies a and b and places the result in r (`r=a*b`). r may be the same BIGNUM as a or b. For multiplication by powers of 2, use BN_mod_mul_montgomery(3) and BN_CTX_new(3).

Unless noted otherwise, the result BIGNUM must be different from the arguments.

# RETURN VALUES

For all functions, 1 is returned for success, 0 on error. The return value should always be checked (e.g., `if (!BN_add(r,a,b)) goto err;`). The error codes can be obtained by SEE ALSO

BN_CTX_new(3), BN_set_bit(3)

# COPYRIGHT

Copyright 2000-2018 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the OpenSSL license (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.